package app;

import com.is2t.mwt.composites.FlowComposite;
import com.is2t.mwt.composites.GridComposite;
import com.is2t.mwt.widgets.LookExtension;
import com.is2t.mwt.widgets.button.Button;
import com.is2t.mwt.widgets.label.TitleLabel;
import com.is2t.mwt.widgets.renderers.plain.theme.PlainTheme;
import com.is2t.mwt.widgets.tiny.Scale;
import com.is2t.mwt.widgets.tiny.TextField;

import ej.mwt.Desktop;
import ej.mwt.MWT;
import ej.mwt.Panel;

public class Main {
	public static void main(String[] args) {

		DAC dac = new DAC();
		ADC adc = new ADC();
		
		dac.init();
		adc.init();
		
		MWT.RenderingContext.add(new PlainTheme());
		Desktop desktop = new Desktop();
		Panel panel = new Panel();
		GridComposite gc = new GridComposite(MWT.VERTICAL, 4);
		
		TitleLabel title = new TitleLabel("ADC/DAC EXAMPLE");
		title.setFontSize(LookExtension.GET_X_BIG_FONT_INDEX);
		gc.add(title);
		
		FlowComposite fcDac = new FlowComposite();
		
		TitleLabel labelDacTitle = new TitleLabel("Dac Value [mV]:");
		fcDac.add(labelDacTitle);
		
		TextField dacValueField = new TextField("--------");
		fcDac.add(dacValueField);
		
		Scale scaleDac = new Scale(0, 300);
		scaleDac.setListener(new DACScaleListener(dacValueField, dac));
		fcDac.add(scaleDac);
		
		gc.add(fcDac);

		FlowComposite fcAdc = new FlowComposite();
		
		TitleLabel labelAdcTitle = new TitleLabel("ADC Value [mV]:");
		fcAdc.add(labelAdcTitle);
		
		TextField adcValueField = new TextField("--------");
		fcAdc.add(adcValueField);
		
		Button buttonAdc = new Button("Get ADC value");
		buttonAdc.setListener(new ADCButtonListener(adcValueField, adc));
		fcAdc.add(buttonAdc);

		gc.add(fcAdc);
		
		panel.setWidget(gc);
		panel.show(desktop, true);
		desktop.show();
	}

}
